shaders = {
  blur1 = love.graphics.newShader [[
    vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords)	{
      vec4 sum = vec4(0.0);
      number blurSize = 0.005;

      // take nine samples, with the distance blurSize between them
      sum += texture2D(texture, vec2(vTexCoord.x - 4.0*blurSize, vTexCoord.y)) * 0.05;
      sum += texture2D(texture, vec2(vTexCoord.x - 3.0*blurSize, vTexCoord.y)) * 0.09;
      sum += texture2D(texture, vec2(vTexCoord.x - 2.0*blurSize, vTexCoord.y)) * 0.12;
      sum += texture2D(texture, vec2(vTexCoord.x - blurSize, vTexCoord.y)) * 0.15;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
      sum += texture2D(texture, vec2(vTexCoord.x + blurSize, vTexCoord.y)) * 0.15;
      sum += texture2D(texture, vec2(vTexCoord.x + 2.0*blurSize, vTexCoord.y)) * 0.12;
      sum += texture2D(texture, vec2(vTexCoord.x + 3.0*blurSize, vTexCoord.y)) * 0.09;
      sum += texture2D(texture, vec2(vTexCoord.x + 4.0*blurSize, vTexCoord.y)) * 0.05;

      return sum;
    }]],
  blur2 = love.graphics.newShader [[
    vec4 effect(vec4 color, Image texture, vec2 vTexCoord, vec2 pixel_coords) {
      vec4 sum = vec4(0.0);
      number blurSize = 0.005;

      // take nine samples, with the distance blurSize between them
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 4.0*blurSize)) * 0.05;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 3.0*blurSize)) * 0.09;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y - 2.0*blurSize)) * 0.12;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y- blurSize)) * 0.15;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y)) * 0.16;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + blurSize)) * 0.15;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 2.0*blurSize)) * 0.12;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 3.0*blurSize)) * 0.09;
      sum += texture2D(texture, vec2(vTexCoord.x, vTexCoord.y + 4.0*blurSize)) * 0.05;

      return sum;
    }]],

  glow2 = love.graphics.newShader [[
    extern vec2 size=vec2(1280,720);

    vec4 effect(vec4 colour, Image tex, vec2 tc, vec2 sc) {
      vec4 source = Texel(tex, tc);
      vec4 sum = vec4(0);
      int diff = 6;
      vec2 sizeFactor = vec2(1) / size;

      for (int x = -diff; x <= diff; x++)
      {
        for (int y = -diff; y <= diff; y++)
        {
          vec2 offset = vec2(x, y) * sizeFactor;
          sum += Texel(tex, tc + offset);
        }
      }
      number al = sum.a / 9.8;

      if (al > 0.2) al = 0.2;

      return vec4(sum.rgb / 7, al) + source;
    }]],

  glow = love.graphics.newShader [[
    extern vec2 size=vec2(1280,720);

    vec4 effect(vec4 colour, Image tex, vec2 tc, vec2 sc) {
      vec4 source = Texel(tex, tc);
      vec4 sum = vec4(0);
      int diff = 6;
      vec2 sizeFactor = vec2(1) / size;

      for (int x = -diff; x <= diff; x++)
      {
        for (int y = -diff; y <= diff; y++)
        {
          vec2 offset = vec2(x, y) * sizeFactor;
          sum += Texel(tex, tc + offset);
        }
      }
      number al = sum.a / 9.8;

      return vec4(sum.rgb / 7, al) + source;
    }]],
}
