lume = require("lib.lume")

TextBox = {
  time = 0,
  messageQueue = {},
  messagePos = 1,
  currentMessage = "",
  speed = 4,
  color = {255, 255, 255},
  font = love.graphics.newFont("res/font.ttf", 72)
}

function TextBox:QueueMessage(message, pic)
  self.messageQueue[#self.messageQueue + 1] = {m = message, p = pic}
end

function TextBox:PopMessage()
  self.currentMessage = ""
  self.speed = 4
  self.color = {255, 255, 255}
  self.time = 0
  self.messagePos = 1
  table.remove(self.messageQueue, 1)
end

function TextBox:Update(dt)
  if #self.messageQueue == 0 then return end

  if self.messagePos > self.messageQueue[1].m:len() then
    if love.keyboard.isDown('return', ' ') then
      self:PopMessage()
    end
    return
  end

  self.time = self.time + 1
  local token = ""
  if self.time >= self.speed then
    self.time = 0
    token = self.messageQueue[1].m:sub(self.messagePos, self.messagePos)
    self.messagePos = self.messagePos + 1
    gameCamera.shake = gameCamera.shake + 1.5
  end

  self.currentMessage = self.currentMessage .. token
end

function TextBox:Draw()
  if #self.messageQueue > 0 then
    love.graphics.push()
    --love.graphics.scale(0.33, 0.33, 0.33)
    local sx = (math.random() - 0.5) * 2 * gameCamera.shake * 2
    local sy = (math.random() - 0.5) * 2 * gameCamera.shake * 2
    love.graphics.translate(math.floor(sx), math.floor(sy))

    love.graphics.setFont(self.font)
    love.graphics.setColor(52, 52, 52)
    love.graphics.rectangle("fill", 33, 579, 1280, 720 - 556)
    love.graphics.setColor(255, 255, 255)
    love.graphics.print(self.currentMessage, 100 + (720 - 576), 590)
    if self.messageQueue[1].p ~= nil then
      love.graphics.draw(self.messageQueue[1].p, 65, 586)
    end
    love.graphics.pop()
  end
end

function TextBox:HasMessage()
  return #self.messageQueue > 0
end
